import unittest
import manage_sys_paths

from messaging.DummyMessageManager import DummyMessageManager
# init dummy message manager so no connection to rabbitmq is established
_ = DummyMessageManager.get_instance()

import routes.blockchain_trace as blockchain_trace
from env_info import get_resources_path
from security.token_manager import TokenManager
import network_constants
import json
import requests

class Test_BlockchainTrace(unittest.TestCase):

    def test_isBlockchainTraceValid_validInputAndTypes(self):
        with open(f"{get_resources_path()}/pizza_transactions.json") as f:
            transactions = json.loads(f.read())
        
        jwt = TokenManager.getInstance().getToken()

        for transaction in transactions:
            url = f'https://{network_constants.REST_GATEWAY_HOSTNAME}:{network_constants.REST_GATEWAY_REST_PORT}/api/trace'

            response = requests.post(
                    url,
                    verify = False, 
                    proxies = { "http":None, "https":None },
                    headers = {"Authorization": f"Bearer {jwt}"},
                    json = transaction
            )

            print(f"{url} {response.status_code}")

            if response.status_code != 201:
                print(f"server responded with {response.status_code}: {response.text}")

            self.assertTrue(response.status_code==201, "Should accept the new trace.")

        

if __name__ == '__main__':
    unittest.main()